//---------------------------------------------------------------------------
#ifndef SButtonH
#define SButtonH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl/dsgnintf.hpp>

class TSModalResult : TPersistent
{
private:
	int FResult;
public:
	__fastcall TSModalResult();
__published:
	__property int Result = {read=FResult, write=FResult, default = mrNone};
};

//---------------------------------------------------------------------------
class TSModalResultProperty : public TEnumProperty
{
public:
	virtual TPropertyAttributes __fastcall GetAttributes(void);
public:
	__fastcall virtual TSModalResultProperty(void);
	__fastcall virtual ~TSModalResultProperty(void);
	virtual void __fastcall GetValues(Classes::TGetStrProc Proc);
	AnsiString __fastcall GetValue();
    void __fastcall SetValue(AnsiString Value);
};

//---------------------------------------------------------------------------
class TSButton : public TCustomControl
{
private:
	Graphics::TBitmap *FBitmapNormal;
	Graphics::TBitmap *FBitmapActive;
	Graphics::TBitmap *FBitmapDown;
	void __fastcall SetBitmapNormal(Graphics::TBitmap *Value);
	Graphics::TBitmap *__fastcall GetBitmapNormal();
	void __fastcall SetBitmapActive(Graphics::TBitmap *Value);
	Graphics::TBitmap *__fastcall GetBitmapActive();
	void __fastcall SetBitmapDown(Graphics::TBitmap *Value);
	Graphics::TBitmap *__fastcall GetBitmapDown();
   	bool FAutosize;
	void __fastcall SetAutosize(bool Value);
    bool FDefault;
    bool FCancel;
    //Forms::TModalResult FModalResult;
    TSModalResult *FModalResult;
    bool FClicksDisabled;
    void __fastcall SetDefault(bool Value);
	void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
   	void __fastcall MouseDown(TMouseButton Button,  Classes::TShiftState Shift, int X, int Y);
   	void __fastcall MouseUp(TMouseButton Button,  Classes::TShiftState Shift, int X, int Y);
    void __fastcall Paint();
    void __fastcall Click();
    void __fastcall CreateParams(TCreateParams &Params);
    void __fastcall WndProc(Messages::TMessage &Message);
    void __fastcall Resize(Graphics::TBitmap *Value);
    bool FPressed;
    bool FActive;
    bool FFocused;
    void __fastcall DrawBitmap();
    void __fastcall SetStyle(bool Default);
	MESSAGE void __fastcall CMFocusChanged(Controls::TCMFocusChanged &Message);
    MESSAGE void __fastcall CMDialogKey(Messages::TWMKey &Message);
    MESSAGE void __fastcall CNCommand(Messages::TWMCommand &Message);
protected:
public:
	virtual __fastcall TSButton(TComponent* Owner);
    virtual __fastcall ~TSButton();
__published:
	__property Graphics::TBitmap *BitmapNormal ={read=GetBitmapNormal, write=SetBitmapNormal, nodefault};
	__property Graphics::TBitmap *BitmapActive ={read=GetBitmapActive, write=SetBitmapActive, nodefault};
	__property Graphics::TBitmap *BitmapDown ={read=GetBitmapDown, write=SetBitmapDown, nodefault};
    __property bool Autosize ={read=FAutosize, write=SetAutosize};
    __property bool Default ={read=FDefault, write=SetDefault, default=FALSE};
    __property bool Cancel  ={read=FCancel, write=FCancel, default=FALSE};
	//__property Forms::TModalResult ModalResult = {read=FModalResult, write=FModalResult, default=mrNone};
	__property TSModalResult *ModalResult = {read=FModalResult, write=FModalResult};
    __property OnClick;
    __property OnDragDrop;
    __property OnDragOver;
    __property OnEndDrag;
    __property OnEnter;
    __property OnExit;
    __property OnKeyDown;
    __property OnKeyUp;
    __property OnKeyPress;
	__property OnMouseDown;
    __property OnMouseUp;
    __property OnMouseMove;
    __property OnStartDrag;
    __property DragCursor;
    __property DragMode;
    __property Enabled;
    __property ParentShowHint;
    __property PopupMenu;
    __property ShowHint;
    __property TabOrder;
    __property TabStop;
    __property Visible;
BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(CM_FOCUSCHANGED, Controls::TCMFocusChanged, CMFocusChanged);
    MESSAGE_HANDLER(CM_DIALOGKEY, Messages::TWMKey, CMDialogKey);
    MESSAGE_HANDLER(CN_COMMAND, Messages::TWMCommand, CNCommand);
END_MESSAGE_MAP(TCustomControl);
};
//---------------------------------------------------------------------------
#endif
