//---------------------------------------------------------------------------
#ifndef SLedH
#define SLedH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#define STATE_ON 1
#define STATE_OFF 0
#define GREEN 1

enum TLEDColor {lsGreen, lsRed};

//---------------------------------------------------------------------------
class TSLed : public TCustomControl
{
private:
	int FFlashTimeOn;
    int FFlashTimeOff;
    TLEDColor FLEDColor;
    int FState;
    bool FFlash;
    bool FPower;
	Graphics::TBitmap *FBitmapGray;
	Graphics::TBitmap *FBitmapRed;
	Graphics::TBitmap *FBitmapGreen;
	Graphics::TBitmap *FBitmap;
    void __fastcall SetLEDColor(TLEDColor Value);
    void __fastcall SetBitmapGray(Graphics::TBitmap * Value);
    void __fastcall SetBitmapRed(Graphics::TBitmap * Value);
    void __fastcall SetBitmapGreen(Graphics::TBitmap * Value);
    void __fastcall SetFlash(bool Value);
    void __fastcall SetPower(bool Value);
    void __fastcall Paint();
    MESSAGE void __fastcall OnTimer(Messages::TWMTimer &Message);
protected:
public:
	__fastcall TSLed(TComponent* Owner);
    __fastcall ~TSLed();
__published:
    __property Graphics::TBitmap *BitmapGray = {read=FBitmapGray, write=SetBitmapGray, stored=true};
    __property Graphics::TBitmap *BitmapRed = {read=FBitmapRed, write=SetBitmapRed, stored=true};
    __property Graphics::TBitmap *BitmapGreen = {read=FBitmapGreen, write=SetBitmapGreen, stored=true};
	__property int FlashTimeOn = {read=FFlashTimeOn, write=FFlashTimeOn, default=100};
	__property int FlashTimeOff = {read=FFlashTimeOff, write=FFlashTimeOff, default=100};
    __property TLEDColor LEDColor = {read=FLEDColor, write=SetLEDColor, default=lsGreen};
    __property bool Flash = {read=FFlash, write=SetFlash, default=false};
    __property bool Power = {read=FPower, write=SetPower, default=false};

BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_TIMER, Messages::TWMTimer, OnTimer);
END_MESSAGE_MAP(TCustomControl);
};
//---------------------------------------------------------------------------
#endif
